indexing

   description: "A single MIME parameter as it occurs in a MIME header field."
   
   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   EPX_MIME_PARAMETER


creation
   
   make
   

feature -- creation
   
   make (a_name, a_value: STRING) is
      require
         valid_name: a_name /= Void and then not a_name.is_empty
         valid_value: a_value /= Void
      do
         name := a_name
         name.to_lower
         value := a_value
      end
   

feature -- state
   
   file: STDC_TEMPORARY_FILE
         -- optional, valid for input type file 
         -- gives access to file as saved on server disk
   
   name: STRING
         -- name of MIME field, lowercase only
   
   value: STRING
         -- value of key


feature -- change state
   
   set_file (a_file: STDC_TEMPORARY_FILE) is
      require
         valid_file: a_file /= Void and then a_file.is_open
      do
         file := a_file
      end
   

invariant
   
   has_name: name /= Void and then not name.is_empty
   has_value: value /= Void   
   valid_file: file /= Void implies not value.is_empty
   
   
end -- class EPX_MIME_PARAMETER
