indexing

   description: "Class that covers portable Windows current process code."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class

   EPX_CURRENT_PROCESS


inherit

   ABSTRACT_CURRENT_PROCESS

   POSIX_PROCESS

   POSIX_BASE

   PAPI_UNISTD


feature -- every process also has standard file descriptors

   fd_stdin: POSIX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (STDIN_FILENO)
      end

   fd_stdout: POSIX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (STDOUT_FILENO)
      end

   fd_stderr: POSIX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (STDERR_FILENO)
      end


feature {NONE} -- abstract API

   abstract_getpid: INTEGER is
      do
         Result := posix_getpid
      end

   abstract_sleep (a_seconds: INTEGER): INTEGER is
      do
         Result := posix_sleep (a_seconds)
      end


end
