indexing

   description: "Class that covers the Single Unix Spec netdb.h header."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"
   
   
class 

   SAPI_NETDB

   
feature {NONE} -- host functions
   
   posix_gethostbyname (a_hostname: POINTER): POINTER is
      require
         valid_hostname: a_hostname /= default_pointer
      external "C"
      ensure
         -- Result = default_pointer implies h_errno.is_not_ok
      end
   
   posix_getservbyname (a_name, proto: POINTER): POINTER is
      require
         valid_name: a_name /= default_pointer
      external "C"
      end
   
   posix_getservbyport (a_port: INTEGER; proto: POINTER): POINTER is
      require
         valid_port: a_port >= 0
      external "C"
      end
   

feature {NONE} -- C binding for members of hostent

   posix_hostent_size: INTEGER is
      external "C"
      end

   posix_hostent_h_name (a_hostent: POINTER): POINTER is
      external "C"
      end

   posix_hostent_h_aliases (a_hostent: POINTER): POINTER is
      external "C"
      end

   posix_hostent_h_addrtype (a_hostent: POINTER): INTEGER is
      external "C"
      end

   posix_hostent_h_length (a_hostent: POINTER): INTEGER is
      external "C"
      end

   posix_hostent_h_addr_list (a_hostent: POINTER): POINTER is
      external "C"
      end


feature {NONE} -- C binding for members of servent

   posix_servent_size: INTEGER is
      external "C"
      end

   posix_servent_s_name (a_servent: POINTER): POINTER is
         -- Official service name.
      external "C"
      end

   posix_servent_s_aliases (a_servent: POINTER): POINTER is
         -- Alias list.
      external "C"
      end

   posix_servent_s_port (a_servent: POINTER): INTEGER is
         -- Port number.
      external "C"
      end

   posix_servent_s_proto (a_servent: POINTER): POINTER is
         -- Protocol to use.
      external "C"
      end


end
