indexing

   description: "Converts strings to pointers and vice versa."
   thanks: "The mico/E team for the idea."

   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   EPX_STRING_HELPER


inherit

   ABSTRACT_STRING_HELPER


feature -- ISE specific conversions

   string_to_pointer (s: STRING): POINTER is
      local
         a: ANY
         pr: POINTER_REF         
      do
         if s = Void then
            Result := default_pointer
         else         
            a := s.to_c
            !! pr
            pr.set_item ($a)
            Result := pr.item
         end
      end

   pointer_to_string (p: POINTER): STRING is
      do
         if p = default_pointer then
            Result := ""
         else
            !! Result.make_from_c (p)
         end
      end

   set_string_from_pointer (s: STRING; p: POINTER) is
      do
         if p = default_pointer then
            s.clear_all
         else
            s.make_from_c (p)
         end
      end
   
   
feature -- string utilities that have different names per compiler...   
   
   clear (s: STRING) is
      do
         s.clear_all
      end
   
   insert_character (s: STRING; c: CHARACTER; i: INTEGER) is
      do
         s.insert (c.out, i)
      end
   
   make_with_capacity (capacity: INTEGER): STRING is
         -- create a new string
      do
         create Result.make (capacity)
      end
   

end
