indexing

   description:
   "Describes file related security."

   usage: "Inherit from STDC_SECURITY_ACCESSOR."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   STDC_SECURITY_FILES


inherit

   STDC_SECURITY_ASPECT


creation

   make


feature -- creation

   make is
         -- allow everything
      do
         max_open_files := Max_Int
         open_files := 3 -- stdin, stdout, stderr
      end


feature -- parameters

   max_open_files: INTEGER
         -- max files that may be open

   open_files: INTEGER
         -- how many files are open


feature -- set parameters

   set_max_open_files (value: INTEGER) is
      do
         max_open_files := value
         check_max_open_files
      ensure
         max_open_files >= open_files
      end


feature {STDC_SECURITY_ACCESSOR} -- count resource usage

   decrease_open_files is
      do
         open_files := open_files - 1
      end

   increase_open_files is
      do
         open_files := open_files + 1
         check_max_open_files
      end


feature -- checks

   check_max_open_files is
      do
         if open_files > max_open_files then
            raise_security_error ("Maximum allowed open files exceeded.%N")
         end
      end


end -- class STDC_SECURITY_FILES
