indexing

   description: "Class that covers portable Windows current process code."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   EPX_CURRENT_PROCESS


inherit

   ABSTRACT_CURRENT_PROCESS

   WINDOWS_PROCESS

   WAPI_WINDOWS


feature -- standard file descriptors

   fd_stdin: EPX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (posix_getstdhandle (STD_INPUT_HANDLE))
      end

   fd_stdout: EPX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (posix_getstdhandle (STD_OUTPUT_HANDLE))
      end

   fd_stderr: EPX_FILE_DESCRIPTOR is
      once
         create Result.attach_to_fd (posix_getstdhandle (STD_ERROR_HANDLE))
      end


feature {NONE} -- abstract API

   abstract_getpid: INTEGER is
      do
         Result := posix_getcurrentprocessid
      end

   abstract_sleep (a_seconds: INTEGER): INTEGER is
      do
         posix_sleep (a_seconds * 1000)
         Result := 0
      end


end
