indexing

	description: "Windows symbolic constants"

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"

class 

   WINDOWS_CONSTANTS

inherit

   STDC_CONSTANTS

   
feature {NONE} -- Windows open symbolic constants

   O_APPEND: INTEGER is
         -- Set the file offset to the end-of-file prior to each write
      external "C"
      alias "const_o_append"
      end
   
   O_BINARY: INTEGER is
         -- Opens file in binary (untranslated) mode. 
      external "C"
      alias "const_o_binary"
      end
   
   O_CREAT: INTEGER is
         -- If the file does not exist, allow it to be created. This 
         -- flag indicates that the mode argument is present in the 
         -- call to open.
      external "C"
      alias "const_o_creat"
      end
   
   O_EXCL, O_EXCLUSIVE: INTEGER is
         -- Open fails if the file already exists
      external "C"
      alias "const_o_excl"
      end
   
   O_RANDOM: INTEGER is
         -- Specifies primarily random access from disk
      external "C"
      alias "const_o_random"
      end
   
   O_RDONLY: INTEGER is
         -- Open for reading only
      external "C"
      alias "const_o_rdonly"
      end

   O_RDWR: INTEGER is
         -- Open fo reading and writing
      external "C"
      alias "const_o_rdwr"
      end
   
   O_SHORT_LIVED: INTEGER is
         -- Create file as temporary and if possible do not flush to disk. 
      external "C"
      alias "const_o_short_lived"
      end
   
   O_TEMPORARY: INTEGER is
         -- Create file as temporary; file is deleted when last file
         -- handle is closed.      
      external "C"
      alias "const_o_temporary"
      end
   
   O_SEQUENTIAL: INTEGER is
         -- Specifies primarily sequential access from disk
      external "C"
      alias "const_o_sequential"
      end
   
   O_TEXT: INTEGER is
         -- Opens file in text (translated) mode. 
      external "C"
      alias "const_o_text"
      end
   
   O_TRUNC: INTEGER is
         -- Use only on ordinary files opened for writing. It causes 
         -- the file to be truncated to zero length.
      external "C"
      alias "const_o_trunc"
      end
   
   O_WRONLY: INTEGER is
         -- Open for writing only
      external "C"
      alias "const_o_wronly"
      end
   
   
feature {NONE} -- Windows permission symbolic constants
   
   S_IEXEC: INTEGER is
         -- execute/search permission, owner
      external "C"
      alias "const_s_iexec"
      end
   
   S_IREAD: INTEGER is
         -- read permission, owner
      external "C"
      alias "const_s_iread"
      end

   S_IWRITE: INTEGER is
         -- write permission, owner
      external "C"
      alias "const_s_iwrite"
      end
   

feature {NONE} -- Windows errorcodes
   
   EAGAIN: INTEGER is
      external "C"
      alias "const_eagain"
      end
   
   EINTR: INTEGER is
      external "C"
      alias "const_eintr"
      end
   

end -- class WINDOWS_CONSTANTS
