indexing

   description: "Test POSIX file class."

   Bugs: "1. Assumes 8 bit characters."
  
   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 
   
   TEST_P_FILE

inherit
   
   POSIX_CURRENT_PROCESS

   POSIX_FILE_SYSTEM


creation
   
   make


feature
   
   make is
      local
         file: POSIX_TEXT_FILE
         fd: POSIX_FILE_DESCRIPTOR
         timed_fin: POSIX_TIMED_FIN_CHARACTER
         tmpfile: POSIX_TEMPORARY_FILE
      do
         print ("Testing Posix file interface.%N")

         print ("Get file descriptor.%N")
         create file.open_append ("test.berend")
         create fd.make_from_file (file)
         print ("fildes: ")
         print (fd.value)
         print ("%N")
         file.close

         print ("Test make from file descriptor.%N")
         create fd.open_read ("test.berend")
         create file.make_from_file_descriptor (fd, "r")
         file.close
         remove_file ("test.berend")

         print ("Test wait for input.%N")
         print ("Press Enter to continue or wait 5 seconds.%N")
         create timed_fin.make (5, stdin)
         if timed_fin.execute then
            print ("no timeout.%N")
         else
            print ("timeout.%N")
         end

         print ("Create a temporary file.%N")
         create tmpfile.make
         tmpfile.puts ("hello%N")
         tmpfile.close

         test_read

         print ("End of Posix file test.%N")
      end

   test_read is
         -- test reading bytes in chunks
      local
         chunk_size: INTEGER
         buf: POSIX_DYNAMIC_MEMORY
         fd: POSIX_BINARY_FILE
         file_size: INTEGER
         bytes_read: INTEGER
      do
         print ("Test reading chunks.%N")
         file_size := status ("/bin/sh").size
         print ("filesize: ")
         print (file_size)
         print ("%N")
         chunk_size := 512
         create buf.allocate (chunk_size)
         if is_readable ("/bin/sh.exe") then
            -- cygwin
            create fd.open_read ("/bin/sh.exe")
         else
            create fd.open_read ("/bin/sh")
         end
         from
            fd.read_buffer (buf, 0, chunk_size)            
         until
            fd.eof
         loop
            bytes_read := bytes_read + fd.last_read
            fd.read_buffer (buf, 0, chunk_size)
         end
         fd.close
         buf.deallocate
         if bytes_read /= file_size then
            print ("!! not all bytes read.%N")
         end
      end


end -- class TEST_P_FILE
